"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.decompressMessage = exports.compressMessage = exports.GZIP_MARKER = void 0;
const zlib_1 = require("zlib");
const util_1 = require("util");
const compress = (0, util_1.promisify)(zlib_1.brotliCompress);
const decompress = (0, util_1.promisify)(zlib_1.brotliDecompress);
exports.GZIP_MARKER = '__SQS_GZIP__';
const compressMessage = (message) => {
    return compress(Buffer.from(message))
        .then((buffer) => {
        return Promise.resolve(Buffer.from(buffer).toString('base64'));
    });
};
exports.compressMessage = compressMessage;
const decompressMessage = (body) => {
    return decompress(Buffer.from(body, 'base64'))
        .then((bufferUnziped) => {
        return Promise.resolve(bufferUnziped.toString('utf8'));
    });
};
exports.decompressMessage = decompressMessage;
//# sourceMappingURL=gzipUtils.js.map