"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSizeInBytes = exports.getMessageSize = void 0;
const getMessageSize = (message) => {
    const msgAttributesSize = getMsgAttributesSize(message.MessageAttributes);
    const msgBodySize = (0, exports.getSizeInBytes)(message.MessageBody);
    return msgAttributesSize + msgBodySize;
};
exports.getMessageSize = getMessageSize;
const getSizeInBytes = (obj) => {
    return obj ? Buffer.byteLength(obj) : 0;
};
exports.getSizeInBytes = getSizeInBytes;
const getMsgAttributesSize = (attributes) => {
    let totalMsgAttributesSize = 0;
    attributes = attributes || {};
    for (const attribute in attributes) {
        if (attributes.hasOwnProperty(attribute)) {
            totalMsgAttributesSize += (0, exports.getSizeInBytes)(attribute);
            const val = attributes[attribute];
            totalMsgAttributesSize += (0, exports.getSizeInBytes)(val.DataType);
            totalMsgAttributesSize += (0, exports.getSizeInBytes)(val.StringValue);
            // @ts-ignore
            totalMsgAttributesSize += (0, exports.getSizeInBytes)(val.BinaryValue);
        }
    }
    return totalMsgAttributesSize;
};
//# sourceMappingURL=messageSizeUtils.js.map